1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
40 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev
/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|
*' --va'*)
61 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $?
> $BASE.
exit) |
tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
84 my $ok = join("|", qw(
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
101 GIT_AUTHOR_EMAIL
=author@example.com
102 GIT_AUTHOR_NAME
='A U Thor'
103 GIT_COMMITTER_EMAIL
=committer@example.com
104 GIT_COMMITTER_NAME
='C O Mitter'
105 GIT_MERGE_VERBOSITY
=5
106 GIT_MERGE_AUTOEDIT
=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
114 export GIT_TRACE_BARE
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
118 GIT_INDEX_VERSION
="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
127 setup_malloc_check
() {
130 teardown_malloc_check
() {
134 setup_malloc_check
() {
135 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
138 teardown_malloc_check
() {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
143 # Protect ourselves from common misconfiguration to export
144 # CDPATH into the environment
150 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
152 echo "* warning: Some tests will not work if GIT_TRACE" \
153 "is set as to trace on STDERR ! *"
154 echo "* warning: Please set GIT_TRACE to something" \
155 "other than 1, 2 or true ! *"
161 # A regexp to match 5 and 40 hexdigits
162 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
163 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
166 _z40
=0000000000000000000000000000000000000000
172 export _x05 _x40 _z40 LF
174 # Each test should start with something like this, after copyright notices:
176 # test_description='Description of this test...
177 # This test checks if command xyzzy does the right thing...
180 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
181 TERM
=$ORIGINAL_TERM &&
184 tput bold
>/dev
/null
2>&1 &&
185 tput setaf
1 >/dev
/null
2>&1 &&
186 tput sgr0
>/dev
/null
2>&1
190 while test "$#" -ne 0
193 -d|
--d|
--de|
--deb|
--debu|
--debug)
195 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
196 immediate
=t
; shift ;;
197 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
198 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
200 shift; test "$#" -ne 0 ||
{
201 echo 'error: -r requires an argument' >&2;
204 run_list
=$1; shift ;;
206 run_list
=$
(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
207 -h|
--h|
--he|
--hel|
--help)
209 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
212 verbose_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
214 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
215 # Ignore --quiet under a TAP::Harness. Saying how many tests
216 # passed without the ok/not ok details is always an error.
217 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
219 with_dashes
=t
; shift ;;
222 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
226 valgrind
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
229 valgrind_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
232 shift ;; # was handled already
234 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
237 echo "error: unknown test option '$1'" >&2; exit 1 ;;
241 if test -n "$valgrind_only"
243 test -z "$valgrind" && valgrind
=memcheck
244 test -z "$verbose" && verbose_only
="$valgrind_only"
245 elif test -n "$valgrind"
258 tput bold
; tput setaf
1;; # bold red
260 tput setaf
4;; # blue
262 tput setaf
3;; # brown/yellow
264 tput setaf
2;; # green
266 tput setaf
6;; # cyan
268 test -n "$quiet" && return;;
278 test -z "$1" && test -n "$quiet" && return
285 say_color error
"error: $*"
294 test "${test_description}" != "" ||
295 error
"Test script did not set test_description."
297 if test "$help" = "t"
299 printf '%s\n' "$test_description"
305 if test "$verbose" = "t"
309 exec 4>/dev
/null
3>/dev
/null
318 test_external_has_tap
=0
322 if test -n "$GIT_EXIT_OK"
326 echo >&5 "FATAL: Unexpected exit with code $code"
334 # The user-facing functions are loaded from a separate file so that
335 # test_perf subshells can have them too
336 .
"$TEST_DIRECTORY/test-lib-functions.sh"
338 # You are not expected to call test_ok_ and test_failure_ directly, use
339 # the test_expect_* functions instead.
342 test_success
=$
(($test_success + 1))
343 say_color
"" "ok $test_count - $@"
347 test_failure
=$
(($test_failure + 1))
348 say_color error
"not ok $test_count - $1"
350 printf '%s\n' "$*" |
sed -e 's/^/# /'
351 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
354 test_known_broken_ok_
() {
355 test_fixed
=$
(($test_fixed+1))
356 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
359 test_known_broken_failure_
() {
360 test_broken
=$
(($test_broken+1))
361 say_color warn
"not ok $test_count - $@ # TODO known breakage"
365 test "$debug" = "" ||
eval "$1"
368 match_pattern_list
() {
371 test -z "$*" && return 1
382 match_test_selector_list
() {
387 test -z "$1" && return 0
389 # Both commas and whitespace are accepted as separators.
395 # If the first selector is negative we include by default.
403 orig_selector
=$selector
409 selector
=${selector##?}
413 test -z "$selector" && continue
417 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
419 echo "error: $title: invalid non-numeric in range" \
420 "start: '$orig_selector'" >&2
423 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
425 echo "error: $title: invalid non-numeric in range" \
426 "end: '$orig_selector'" >&2
431 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
433 echo "error: $title: invalid non-numeric in test" \
434 "selector: '$orig_selector'" >&2
439 # Short cut for "obvious" cases
440 test -z "$include" && test -z "$positive" && continue
441 test -n "$include" && test -n "$positive" && continue
445 if test $arg -le ${selector#-}
451 if test $arg -ge ${selector%-}
457 if test ${selector%%-*} -le $arg \
458 && test $arg -le ${selector#*-}
464 if test $arg -eq $selector
475 maybe_teardown_verbose
() {
476 test -z "$verbose_only" && return
477 exec 4>/dev
/null
3>/dev
/null
482 maybe_setup_verbose
() {
483 test -z "$verbose_only" && return
484 if match_pattern_list
$test_count $verbose_only
487 # Emit a delimiting blank line when going from
488 # non-verbose to verbose. Within verbose mode the
489 # delimiter is printed by test_expect_*. The choice
490 # of the initial $last_verbose is such that before
491 # test 1, we do not print it.
492 test -z "$last_verbose" && echo >&3 ""
495 exec 4>/dev
/null
3>/dev
/null
498 last_verbose
=$verbose
501 maybe_teardown_valgrind
() {
502 test -z "$GIT_VALGRIND" && return
503 GIT_VALGRIND_ENABLED
=
506 maybe_setup_valgrind
() {
507 test -z "$GIT_VALGRIND" && return
508 if test -z "$valgrind_only"
510 GIT_VALGRIND_ENABLED
=t
513 GIT_VALGRIND_ENABLED
=
514 if match_pattern_list
$test_count $valgrind_only
516 GIT_VALGRIND_ENABLED
=t
521 # This is a separate function because some tests use
522 # "return" to end a test_expect_success block early.
523 eval </dev
/null
>&3 2>&4 "$*"
532 teardown_malloc_check
534 if test -z "$immediate" ||
test $eval_ret = 0 ||
test -n "$expecting_failure"
537 test_eval_
"$test_cleanup"
538 teardown_malloc_check
540 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
548 test_count
=$
(($test_count+1))
555 maybe_teardown_valgrind
556 maybe_teardown_verbose
562 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
565 skipped_reason
="GIT_SKIP_TESTS"
567 if test -z "$to_skip" && test -n "$test_prereq" &&
568 ! test_have_prereq
"$test_prereq"
573 if test "$missing_prereq" != "$test_prereq"
575 of_prereq
=" of $test_prereq"
577 skipped_reason
="missing $missing_prereq${of_prereq}"
579 if test -z "$to_skip" && test -n "$run_list" &&
580 ! match_test_selector_list
'--run' $test_count "$run_list"
583 skipped_reason
="--run"
588 say_color skip
>&3 "skipping test: $@"
589 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
598 # stub; perf-lib overrides it
599 test_at_end_hook_
() {
606 if test -z "$HARNESS_ACTIVE"
608 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
609 mkdir
-p "$test_results_dir"
611 test_results_path
="$test_results_dir/${base%.sh}-$$.counts"
613 cat >>"$test_results_path" <<-EOF
615 success $test_success
623 if test "$test_fixed" != 0
625 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
627 if test "$test_broken" != 0
629 say_color warn
"# still have $test_broken known breakage(s)"
631 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
633 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
634 msg
="remaining $test_remaining test(s)"
636 test_remaining
=$test_count
637 msg
="$test_count test(s)"
639 case "$test_failure" in
641 # Maybe print SKIP message
642 if test -n "$skip_all" && test $test_count -gt 0
644 error
"Can't use skip_all after running some tests"
646 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
648 if test $test_external_has_tap -eq 0
650 if test $test_remaining -gt 0
652 say_color pass
"# passed all $msg"
654 say
"1..$test_count$skip_all"
657 test -d "$remove_trash" &&
658 cd "$(dirname "$remove_trash")" &&
659 rm -rf "$(basename "$remove_trash")"
666 if test $test_external_has_tap -eq 0
668 say_color error
"# failed $test_failure among $msg"
677 if test -n "$valgrind"
681 test "$1" = "$(readlink "$2")" ||
{
689 while test -d "$2".lock
691 say
"Waiting for lock on $2."
698 make_valgrind_symlink
() {
699 # handle only executables, unless they are shell libraries that
700 # need to be in the exec-path.
702 test "# " = "$(head -c 2 <"$1")" ||
705 base
=$
(basename "$1")
706 symlink_target
=$GIT_BUILD_DIR/$base
707 # do not override scripts
708 if test -x "$symlink_target" &&
709 test ! -d "$symlink_target" &&
710 test "#!" != "$(head -c 2 < "$symlink_target")"
712 symlink_target
=..
/valgrind.sh
716 symlink_target
=..
/unprocessed-script
718 # create the link, or replace it if it is out of date
719 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
722 # override all git executables in TEST_DIRECTORY/..
723 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
724 mkdir
-p "$GIT_VALGRIND"/bin
725 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
727 make_valgrind_symlink
$file
729 # special-case the mergetools loadables
730 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
735 ls "$path"/git-
* 2> /dev
/null |
738 make_valgrind_symlink
"$file"
742 PATH
=$GIT_VALGRIND/bin
:$PATH
743 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
745 GIT_VALGRIND_MODE
="$valgrind"
746 export GIT_VALGRIND_MODE
747 GIT_VALGRIND_ENABLED
=t
748 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
749 export GIT_VALGRIND_ENABLED
750 elif test -n "$GIT_TEST_INSTALLED"
752 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
753 error
"Cannot run git from $GIT_TEST_INSTALLED."
754 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
755 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756 else # normal case, use ../bin-wrappers only unless $with_dashes:
757 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
758 if ! test -x "$git_bin_dir/git"
760 if test -z "$with_dashes"
762 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
766 PATH
="$git_bin_dir:$PATH"
767 GIT_EXEC_PATH
=$GIT_BUILD_DIR
768 if test -n "$with_dashes"
770 PATH
="$GIT_BUILD_DIR:$PATH"
773 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
774 GIT_CONFIG_NOSYSTEM
=1
776 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
778 if test -z "$GIT_TEST_CMP"
780 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
782 GIT_TEST_CMP
="$DIFF -c"
784 GIT_TEST_CMP
="$DIFF -u"
788 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
790 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
791 error
"You haven't built things yet, have you?"
794 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
796 echo >&2 'You need to build test-chmtime:'
797 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
802 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
803 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
804 case "$TRASH_DIRECTORY" in
805 /*) ;; # absolute path is good
806 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
808 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
809 rm -fr "$TRASH_DIRECTORY" ||
{
811 echo >&5 "FATAL: Cannot prepare test area"
815 HOME
="$TRASH_DIRECTORY"
818 if test -z "$TEST_NO_CREATE_REPO"
820 test_create_repo
"$TRASH_DIRECTORY"
822 mkdir
-p "$TRASH_DIRECTORY"
824 # Use -P to resolve symlinks in our working directory so that the cwd
825 # in subprocesses like git equals our $PWD (for pathname comparisons).
826 cd -P "$TRASH_DIRECTORY" ||
exit 1
829 this_test
=${this_test%%-*}
830 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
832 say_color info
>&3 "skipping test $this_test altogether"
833 skip_all
="skip all tests in $this_test"
837 # Provide an implementation of the 'yes' utility
852 # Fix some commands on Windows
855 # Windows has its own (incompatible) sort and find
865 # git sees Windows-style pwd
869 # no POSIX permissions
870 # backslashes in pathspec are converted to '/'
871 # exec does not inherit the PID
872 test_set_prereq MINGW
873 test_set_prereq SED_STRIPS_CR
874 test_set_prereq GREP_STRIPS_CR
875 GIT_TEST_CMP
=mingw_test_cmp
878 test_set_prereq POSIXPERM
879 test_set_prereq EXECKEEPSPID
880 test_set_prereq CYGWIN
881 test_set_prereq SED_STRIPS_CR
882 test_set_prereq GREP_STRIPS_CR
885 test_set_prereq POSIXPERM
886 test_set_prereq BSLASHPSPEC
887 test_set_prereq EXECKEEPSPID
891 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
892 test -z "$NO_PERL" && test_set_prereq PERL
893 test -z "$NO_PYTHON" && test_set_prereq PYTHON
894 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
895 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
897 # Can we rely on git's output in the C locale?
898 if test -n "$GETTEXT_POISON"
900 GIT_GETTEXT_POISON
=YesPlease
901 export GIT_GETTEXT_POISON
902 test_set_prereq GETTEXT_POISON
904 test_set_prereq C_LOCALE_OUTPUT
907 # Use this instead of test_cmp to compare files that contain expected and
908 # actual output from git commands that can be translated. When running
909 # under GETTEXT_POISON this pretends that the command produced expected
912 test -n "$GETTEXT_POISON" || test_cmp
"$@"
915 # Use this instead of "grep expected-string actual" to see if the
916 # output from a git command that can be translated either contains an
917 # expected string, or does not contain an unwanted one. When running
918 # under GETTEXT_POISON this pretends that the command produced expected
921 if test -n "$GETTEXT_POISON"
924 elif test "x!" = "x$1"
933 test_lazy_prereq PIPE
'
934 # test whether the filesystem supports FIFOs
940 rm -f testfifo && mkfifo testfifo
945 test_lazy_prereq SYMLINKS
'
946 # test whether the filesystem supports symbolic links
947 ln -s x y && test -h y
950 test_lazy_prereq FILEMODE
'
951 test "$(git config --bool core.filemode)" = true
954 test_lazy_prereq CASE_INSENSITIVE_FS
'
955 echo good >CamelCase &&
956 echo bad >camelcase &&
957 test "$(cat CamelCase)" != good
960 test_lazy_prereq UTF8_NFD_TO_NFC
'
961 # check whether FS converts nfd unicode to nfc
962 auml=$(printf "\303\244")
963 aumlcdiar=$(printf "\141\314\210")
973 test_lazy_prereq AUTOIDENT
'
974 sane_unset GIT_AUTHOR_NAME &&
975 sane_unset GIT_AUTHOR_EMAIL &&
976 git var GIT_AUTHOR_IDENT
979 test_lazy_prereq EXPENSIVE
'
980 test -n "$GIT_TEST_LONG"
983 test_lazy_prereq USR_BIN_TIME
'
984 test -x /usr/bin/time
987 # When the tests are run as root, permission tests will report that
988 # things are writable when they shouldn't be.
989 test -w / || test_set_prereq SANITY
991 GIT_UNZIP
=${GIT_UNZIP:-unzip}
992 test_lazy_prereq UNZIP
'